/* this class represent input observations, I use this name because
the original application we consider is intensity ratio
*/

#include "MaRatioData.h"

//the constructor read in the data from filename,
//skip is the number of line of skip, not used
MaRatioData::MaRatioData(string filename, int skip){
	ifstream datafile(filename.c_str());
	assert(datafile);
	string line;
	Site site,lastsite;
	bool firstline=true;
	while(getline(datafile,line)){
		istringstream linestream(line);
		linestream>>site;

		/*if you need to consider missing data, uncomment the following, this will fill in
		positions with valie MISSING, note it use SPACING to decide whether somthing observation
		is missing, this is defined in Site.h*/

		//if (!firstline && (site.start-lastsite.start)>SPACING){
		//	fillGap(lastsite,site);
		//}
		firstline=false;
		data.push_back(site);
		obs.push_back(site.obs);
		lastsite=site;
		if(obs.size()>=9000) break;//it is impossible to process 9000 observation! too slow
	}
	obsLen=obs.size();
	cerr<<"number of data:"<<obsLen<<endl;
}

void MaRatioData::fillGap(const Site& lastsite, const Site& site){
	long start=lastsite.start+SPACING;
	while(start<site.start){
		Site fillsite(site.regionName,start,start+PROBELEN);
		data.push_back(fillsite);
		obs.push_back(fillsite.obs);
		start+=SPACING;
	}
}






ostream& operator<<(ostream& os, const MaRatioData& mrdata){
	os<<"number of data points:"<<mrdata.obs.size()<<endl;
	for (int i=0;i<mrdata.obs.size();i++){
		os<<mrdata.data[i].regionName<<"\t"<<mrdata.data[i].start<<"\t"<<
			mrdata.data[i].end<<"\t"<<"\t"<<
			mrdata.data[i].obs<<endl;
	}
	os<<endl;
	return os;
}
